﻿
using Wms.Screen.SqlSugar.Model;
using Wms.Screen.SqlSugar.Repository;
using SqlSugar;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Text;
using Wms.Screen.DataService.Interface;
using Wms.Screen.SqlSugar.Dadihaiyang;

namespace Wms.Screen.DataService.Impl
{
    public class SysDictionaryDataService : BaseDataSetvice, ISysDictionaryDataService
    {
        private IRepository<SysDictionary> _repository;
        private SqlSugarClient _client;
        public SysDictionaryDataService(IRepository<SysDictionary> repository, SqlSugarClient client) : base(client)
        {
            _repository = repository;
            _client = client;
        }
        /// <summary>
        /// 获取字典列表
        /// </summary>
        /// <returns></returns>
        public List<SysDictionary> GetList()
        {
            return _repository.Queryable().Where(p => p.DicCode == EquipType.equip_type)       
                 .OrderBy(p=>p.SortIndex)
                 .ToList();
        }
        public bool IsDictionaryCodeExist(string dictionaryCode)
        {
            return _repository.QueryableIncludeDelete()
                 .Where(p => p.DicCode == dictionaryCode)
                 .Any();
        }     
    }
}
