﻿using SqlSugar;
using System.Collections.Generic;
using Wms.Screen.DataService.Interface;
using Wms.Screen.Dto.ZhongTian.Response.KLHC;
using Wms.Screen.SqlSugar.ZhongTian;
using Wms.Screen.SqlSugar.ZhongTian.KLHC;

namespace Wms.Screen.DataService.Impl
{
    /// <summary>
    /// 空轮缓存库data服务
    /// </summary>
    public class ZhongTianKlhcDataService : IZhongTianKlhcDataService
    {
        /// <summary>
        /// 数据库操作对象
        /// </summary>
        private SqlSugarClient _db;

        /// <summary>
        /// 构造函数
        /// </summary>
        /// <param name="db"></param>
        public ZhongTianKlhcDataService(SqlSugarClient db)
        {
            _db = db;
        }

        /// <summary>
        /// 缓存信息
        /// </summary>
        /// <returns></returns>
        public List<BaseRBCI> GetBaseRrciList()
        {
            var list = _db.Queryable<BaseRBCI>().With(SqlWith.NoLock).Where(x => x.Id != 0).ToList();
            return list;
        }

        /// <summary>
        /// 库存信息
        /// </summary>
        /// <returns></returns>
        public List<KlhcInvInfoRes> GetBaseWarecellList()
        {
            var list = _db.Queryable<BaseWarecell, BillInvnow>((loc, inv) => new object[]
                        {
                            JoinType.Left,loc.ContGrpBarCode==inv.ContGrpBarCode,
                        })
                .Where((loc, inv) => loc.StateNum == 2)
                .Select((loc, inv) => new KlhcInvInfoRes { WheelType = inv.MatCode, Number = inv.LengthQty }).ToList();
            return list;
        }

        /// <summary>
        /// 库存信息
        /// </summary>
        /// <returns></returns>
        public List<WCS_TaskInfo> GetWcsTaskInfoList()
        {
            var list = _db.Queryable<WCS_TaskInfo>()
                .Where(x => x.Status < Dto.ZhongTian.TaskStatus.Finish).ToList();
            return list;
        }
    }
}