﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Wms.Screen.Dto.ZhongTian
{
    public class MySettings
    {
        public int MaternalCareWarning { get; set; } = 1;
        public int PartitionWarning { get; set; } = 1;
        public int VacancyWarning { get; set; } = 20;

    }

    public class Const
    {
        #region redis缓存key
        public const string userId_tokenKey = "userId_token";
        public const string cur_user = "cur_user";
        /// <summary>
        /// 所有用户姓名信息
        /// </summary>
        public const string user_name_list = "user_name_list";
        public const string warehouse_type_list = "warehouse_type_list";
        public const string logic_warehouse_list = "logic_warehouse_list";
        public const string warehouse_list = "warehouse_list";
        public const string unit_name_list = "unit_name_list";
        public const string department_list = "department_list";

        /// <summary>
        /// 设备信息
        /// </summary>
        public const string equi_list = "equi_list";

        #endregion

        /// <summary>
        /// 列表栏要区分颜色的列
        /// </summary>
        public static readonly string[] StateNameFields = new string[] {
            "Status",
            "OutDocumentStateName",
            "WarehouseDocumentStateName",
            "PdaTaskStateName",
            "WcsTaskStateName",
            "AgvTaskStateName",
            "TaskStateName",
            "WarningName",
            "LocationStateName",
            "BarCodeImg",
        };

        public static readonly string JobGroupName = "DefaultGroup";
        public static readonly string TiggerGroupName = "DefaultGroupTrigger";

      
        public const string ExecuteResultSucess = "Sucess";
        public const string ExecuteResultFail = "Fail";

        public const string ProductHouseCode = "producthouse";
        public const string MaterialHouseCode = "materialhouse";

        public const string PreNoticeCount = "NoticeCount_";
        public const string PreTaskCount = "TaskCount_";
        public const string PreWorkPlanCount = "WorkPlanCount_";
        /// <summary>
        /// 原膜最小直径
        /// </summary>
        public const string PlasticFilmMinDiameter = "PlasticFilmMinDiameter";
        /// <summary>
        /// 原膜最大直径
        /// </summary>
        public const string PlasticFilmMaxDiameter = "PlasticFilmMaxDiameter";
        /// <summary>
        /// pvc母托盘一摞的数量
        /// </summary>
        public const string PvcPlasticFilmContainerQuantity = "PvcPlasticFilmContainerQuantity";

        /// <summary>
        /// pvc原膜物料code
        /// </summary>
        public const string PvcPlasticFilmMaterialCodeConst = "PvcPlasticFilmMaterialCodeConst";
        /// <summary>
        /// pvc车间类型
        /// </summary>

        public const string PvcWorkShopTypeConst = "PvcWorkShopType";

        /// <summary>
        /// 设备类型
        /// </summary>
        public const string EquipTypeCode = "EquipType";
        public const string EquipType_PlierCode = "EquipType_Plier";

        /// <summary>
        /// 堆垛机运行状态
        /// </summary>
        public const string PlierRuningStateCode = "PlierRuningState";
        public const string PlierRuningState_AutoCode = "PlierRuningState_Auto";
        public const string PlierRuningState_ManualCode = "PlierRuningState_Manual";
        public const string PlierRuningState_ErrorCode = "PlierRuningState_Error";

        /// <summary>
        /// 出入库单据状态
        /// </summary>
        public const string WarehouseDocumentStateCode = "WarehouseDocumentState";
        public const string WarehouseDocumentState_CreateCode = "WarehouseDocumentState_Create";
        public const string WarehouseDocumentState_ExecuteCode = "WarehouseDocumentState_Execute";
        public const string WarehouseDocumentState_CompletCode = "WarehouseDocumentState_Complete";
        public const string WarehouseDocumentState_PausedCode = "WarehouseDocumentState_Paused";
        public const string WarehouseDocumentState_ClosedCode = "WarehouseDocumentState_Closed";

        #region 合金仓库
        /// <summary>
        /// 合金普通立库
        /// </summary>
        public const string Hjhouse_putong = "hjhouse";
        /// <summary>
        /// 合金二级品仓库
        /// </summary>
        public const string Hjhouse_secondlevel = "hjhouse_erjipin";
        #endregion

        #region 成品仓库
        /// <summary>
        /// 成品普通立库
        /// </summary>
        public const string Cphouse_putong = "Cphouse";
        /// <summary>
        /// 成品二级品仓库
        /// </summary>
        public const string Cphouse_secondlevel = "Cphouse_erjipin";
        #endregion

        #region 盘条仓库
        /// <summary>
        /// 盘条普通立库
        /// </summary>
        public const string Pthouse_putong = "Pthouse";
        /// <summary>
        /// 盘条二级品仓库
        /// </summary>
        public const string Pthouse_secondlevel = "Pthouse_erjipin";
        #endregion

        #region 分拣仓库
        /// <summary>
        /// 分拣普通立库
        /// </summary>
        public const string Fjhouse_putong = "Fjhouse";
        #endregion

        #region 时效仓库
        /// <summary>
        /// 时效普通立库
        /// </summary>
        public const string Sxhouse_putong = "Sxhouse";
        #endregion

        #region 单据类型

        /// <summary>
        /// 派工单(领料单)
        /// </summary>
        public const string WorkPlanBill = "WorkPlanBill";

        #endregion

        /// <summary>
        /// pvc库物料和巷道配置
        /// </summary>
        public const string PvcMaterialWithTunnelType = "PvcMaterialWithTunnelType";

        /// <summary>
        /// pvc库物料入库点位和巷道配置
        /// </summary>
        public const string PvcStartPointWithTunnelType = "PvcStartPointWithTunnelType";
        /// <summary>
        /// 托盘和点位关联关系配置
        /// </summary>
        public const string EquipmentAndContainerRelType = "EquipmentAndContainerRelType";
        /// <summary>
        /// 车间退料点位和物料关系
        /// </summary>
        public const string EquAndContainerRelForWorkBackType = "EquAndContainerRelForWorkBackType";
        /// <summary>
        /// 车间满筐点位
        /// </summary>
        public const string EquAndContainerRelForFullType = "EquAndContainerRelForFullType";


        /// <summary>
        /// 设置值是仓库编码，前面的优先级更高（逗号分隔）
        /// </summary>
        public const string PvcWarehouseOutPriority = "PvcWarehouseOutPriority";

        public const string BakeType_room = "1";
        public const string BakeType_box = "2";


        /// <summary>
        /// PVC二级品仓库-虚拟货位
        /// </summary>
        public const string Pvchouse_secondlevel_Location = "1012";

        /// <summary>
        /// PVC二级品仓库-虚拟大货位
        /// </summary>
        public const string Pvchouse_secondlevel_StoreLocation = "pvcejplocation";

        /// <summary>
        /// ERP基础数据数据同步增量类型
        /// </summary>
        public const string ERPDataInitType = "ERPDataInitType";
        /// <summary>
        /// ERP基础数据数据同步增量类型-物料
        /// </summary>
        public const string ERPMaterialInitIncrement = "ERPMaterialInitIncrement";
        /// <summary>
        /// ERP基础数据数据同步增量类型-单位
        /// </summary>
        public const string ERPUnitInitIncrement = "ERPUnitInitIncrement";
        /// <summary>
        /// ERP基础数据数据同步增量类型-人员
        /// </summary>
        public const string ERPUsersInitIncrement = "ERPUsersInitIncrement";
        /// <summary>
        ///  ERP基础数据数据同步增量类型-供应商
        /// </summary>
        public const string ERPSuperInitIncrement = "ERPSuperInitIncrement";
        /// <summary>
        ///  ERP基础数据数据同步增量类型-客户
        /// </summary>
        public const string ERPCustomerInitIncrement = "ERPCustomerInitIncrement";
        /// <summary>
        /// ERP基础数据数据同步增量类型-部门
        /// </summary>
        public const string ERPDeptInitIncrement = "ERPDeptInitIncrement";
        /// <summary>
        /// ERP基础数据数据同步增量类型-逻辑仓库
        /// </summary>
        public const string ERPLogicWarehouseInitIncrement = "ERPLogicWarehouseInitIncrement";
        /// <summary>
        /// ERP其他入库单数据同步增量类型（调拨）
        /// </summary>
        public const string ERPOtherInOrderInitIncrement = "ERPOtherInOrderInitIncrement";
        /// <summary>
        /// ERP采购入库退货单数据同步增量类型
        /// </summary>
        public const string ERPPurchaseOrderInitIncrement = "ERPPurchaseOrderInitIncrement";
        /// <summary>
        /// ERP销货单/退货数据同步增量类型
        /// </summary>
        public const string ERPVConsignmentdetailInitIncrement = "ERPVConsignmentdetailInitIncrement";
        /// <summary>
        /// ERP发货单/退货数据同步增量类型
        /// </summary>
        public const string ERPVDispatchListSInitIncrement = "ERPVDispatchListSInitIncrement";
        /// <summary>
        /// ERP其他出库单数据同步增量类型
        /// </summary>
        public const string ERPOtherOutOrderInitIncrement = "ERPOtherOutOrderInitIncrement";
        /// <summary>
        /// ERP调拨申请单数据同步增量类型
        /// </summary>
        public const string ERPTransferOrderInitIncrement = "ERPTransferOrderInitIncrement";

        /// <summary>
        /// 禁用巷道(入库)类型
        /// </summary>
        public const string DisableTunnelsType = "DisableTunnelsType";
        /// <summary>
        /// 禁用巷道(出库)类型
        /// </summary>
        public const string DisableTunnelsStockOutType = "DisableTunnelsStockOutType";

    }
}
