﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Reflection;
using System.Text;

namespace Wms.Screen.Dto.ZhongTian
{
    public class EnumClass
    {


    }
    /// <summary>
    /// 货位类型
    /// </summary>
    public enum LocationType
    {
        /// <summary>
        /// 立库货位
        /// </summary>
        LocationType_StorageLocation = 0,
        /// <summary>
        /// 平库货位
        /// </summary>
        LocationType_GroudLocation = 1,
        /// <summary>
        /// 虚拟货位
        /// </summary>
        LocationType_VirtualLocation1 = 2,
    }
    /// <summary>
    /// 货位锁
    /// </summary>
    public enum LocationLock
    {
        /// <summary>
        /// 无锁
        /// </summary>
        LocationLock_None = 0,
        /// <summary>
        /// 入库锁
        /// </summary>
        LocationLock_StockIn = 1,
        /// <summary>
        /// 出库锁
        /// </summary>
        LocationLock_StockOut = 2,
    }
    /// <summary>
    /// 货位是否启用
    /// </summary>
    public enum LocationStop
    {
        /// <summary>
        /// 启用
        /// </summary>
        LocationInvoke = 0,
        /// <summary>
        /// 停用
        /// </summary>
        LocationStopped = 1
    }
   
    /// <summary>
    /// 货位状态
    /// </summary>
    public enum SXLocationState
    {
        /// <summary>
        /// 货位空
        /// </summary>
        [Description("货位空")]
        LocationState_Empty = 1,
        /// <summary>
        /// 货位有货
        /// </summary>
        [Description("货位有货")]
        LocationState_Full = 2,
        /// <summary>
        /// 入库锁
        /// </summary>
        [Description("入库锁")]
        LocationState_StockIn = 3,
        /// <summary>
        /// 出库锁
        /// </summary>
        [Description("出库锁")]
        LocationState_StockOut = 4,
        /// <summary>
        /// 移库锁
        /// </summary>
        [Description("移库锁")]
        LocationState_StockMove = 5,
    }
    /// <summary>
    /// 货位状态
    /// </summary>
    public enum FJLocationState
    {
        /// <summary>
        /// 货位空
        /// </summary>
        [Description("货位空")]
        LocationState_Empty = 1,
        /// <summary>
        /// 货位有货
        /// </summary>
        [Description("货位有货")]
        LocationState_Full = 2,
        /// <summary>
        /// 入库锁
        /// </summary>
        [Description("入库锁")]
        LocationState_StockIn = 3,
        /// <summary>
        /// 出库锁
        /// </summary>
        [Description("出库锁")]
        LocationState_StockOut = 4,
        /// <summary>
        /// 移库锁
        /// </summary>
        [Description("移库锁")]
        LocationState_StockMove = 5,
    }

    /// <summary>
    /// 单据类型
    /// </summary>
    public enum DocType
    {
        /// <summary>
        /// 合金满轮入库
        /// </summary>
        [Description("合金镀铜满轮入库单")]
        DocType_HJ_CopperProductStockIn = 1,
        /// <summary>
        /// 湿拉产线领料
        /// </summary>
        [Description("湿拉产线领料")]
        DocType_HJ_WetLinePickMaterApply = 2,
        /// <summary>
        /// 湿拉产线退料
        /// </summary>
        [Description("湿拉产线退料单")]
        DocType_HJ_WetLineBack = 3,
        /// <summary>
        /// 湿拉产线余料
        /// </summary>
        [Description("湿拉产线余料单")]
        DocType_HJ_WetLineLeft = 4,
        /// <summary>
        /// 合金库库存改判
        /// </summary>
        [Description("合金库库存改判")]
        DocType_HJ_WetLineStockChange = 5,
        /// <summary>
        /// 特殊出库领料
        /// </summary>
        [Description("特殊出库领料")]
        DocType_HJ_SpecialStockOut = 6,

        /// <summary>
        /// 湿拉入库单
        /// </summary>
        [Description("湿拉入库单")]
        DocType_FJ_WetStockIn = 7,
        /// <summary>
        /// 合金空轮初始化入库单
        /// </summary>
        [Description("合金空轮初始化入库单")]
        DocType_HJ_EmptyContStockIn = 8,
        /// <summary>
        /// 帘线领料单
        /// </summary>
        [Description("帘线领料单")]
        DocType_FJ_CurtainProductionStockOut = 11,
    }
    /// <summary>
    /// 单据状态
    /// </summary>
    public enum DocState
    {
        /// <summary>
        /// 新增
        /// </summary>
        [Description("新增")]
        DocState_Create = 1,
        /// <summary>
        /// 执行中
        /// </summary>
        [Description("执行中")]
        DocState_Execute = 2,
        /// <summary>
        /// 完成
        /// </summary>
        [Description("完成")]
        DocState_Complete = 3,
        /// <summary>
        /// 停止
        /// </summary>
        [Description("停止")]
        DocState_Stop = 4,
    }
    /// <summary>
    /// 容器类型
    /// </summary>
    public enum ContainerType
    {
        /// <summary>
        /// RFID
        /// </summary>
        [Description("RFID")]
        ContainerType_RFID,


    }
    /// <summary>
    /// 任务类型
    /// </summary>
    public enum TaskType
    {
        /// <summary>
        /// 组盘
        /// </summary>
        [Description("组盘")]
        SetPlate = 0,

        /// <summary>
        /// 入库
        /// </summary>
        [Description("入库")]
        EnterDepot = 1,

        /// <summary>
        /// 出库
        /// </summary>
        [Description("出库")]
        OutDepot = 2,

        /// <summary>
        /// 移库
        /// </summary>
        [Description("移库")]
        TransferDepot = 3,

        /// <summary>
        /// 输送
        /// </summary>
        [Description("输送")]
        Delivery = 5,
        /// <summary>
        ///  空轮初始化
        /// </summary>
        [Description("空轮初始化")]
        EmptyInit = 6,
    }
    /// <summary>
    /// 任务状态
    /// </summary>
    public enum TaskStatus
    {
        /// <summary>
        /// 新建
        /// </summary>
        [Description("新建")]
        NewBuild = 0,

        /// <summary>
        /// 待执行
        /// </summary>
        [Description("待执行")]
        WaitingToExecute = 1,

        /// <summary>
        /// 帘线扫码
        /// </summary>
        [Description("帘线扫码")]
        帘线扫码 = 9,

        /// <summary>
        /// 巷道分配
        /// </summary>
        [Description("巷道分配")]
        ConveyorExecution = 10,

        /// <summary>
        /// 堆垛机执行
        /// </summary>
        [Description("堆垛机执行")]
        堆垛机执行 = 20,
        /// <summary>
        /// 堆垛机完成
        /// </summary>
        [Description("堆垛机完成")]
        堆垛机完成 = 30,

        /// <summary>
        /// 出库扫码
        /// </summary>
        [Description("出库扫码")]
        出库扫码 = 40,

        /// <summary>
        /// 码垛合流
        /// </summary>
        [Description("码垛合流")]
        码垛合流 = 50,
        /// <summary>
        /// 码垛缓存扫码
        /// </summary>
        [Description("码垛缓存扫码")]
        码垛缓存扫码 = 51,
        /// <summary>
        /// 码垛缓存放行
        /// </summary>
        [Description("码垛缓存放行")]
        码垛缓存放行 = 52,
        /// <summary>
        /// 码垛抓取扫码
        /// </summary>
        [Description("码垛抓取扫码")]
        码垛抓取扫码 = 53,
        /// <summary>
        /// 码垛抓取中
        /// </summary>
        [Description("码垛抓取中")]
        码垛抓取中 = 54,
        /// <summary>
        /// 码垛抓取完成
        /// </summary>
        [Description("码垛抓取完成")]
        码垛抓取完成 = 55,


        /// <summary>
        /// 堆垛机执行
        /// </summary>
        [Description("堆垛机执行")]
        StackerExecution = 20,

        /// <summary>
        /// 堆垛机完成
        /// </summary>
        [Description("堆垛机完成")]
        StackerCompleted = 30,

        /// <summary>
        /// AGV执行中
        /// </summary>
        [Description("AGV执行中")]
        AGVExecution = 40,

        /// <summary>
        /// 已完成
        /// </summary>
        [Description("已完成")]
        Finish = 99,

        /// <summary>
        /// 已取消
        /// </summary>
        [Description("已取消")]
        Cancel = 106
    }

    /// <summary>
    /// 库存状态
    /// </summary>
    public enum InvEcecState
    {
        /// <summary>
        /// 已组盘
        /// </summary>
        [Description("已组盘")]
        InvEcecState_BuildUp = 1,
        /// <summary>
        /// 入库中
        /// </summary>
        [Description("入库中")]
        InvEcecState_InGoing = 2,
        /// <summary>
        /// 已入库
        /// </summary>
        [Description("已入库")]
        InvEcecState_In = 3,
        /// <summary>
        /// 出库中
        /// </summary>
        [Description("出库中")]
        InvEcecState_OutGoing = 4,
        /// <summary>
        /// 已出库
        /// </summary>
        [Description("已出库")]
        InvEcecState_Out = 5,
    }
    /// <summary>
    /// 库存锁定状态
    /// </summary>
    public enum InvState
    {
        /// <summary>
        /// 正常
        /// </summary>
        [Description("正常")]
        InvState_Normal,
        /// <summary>
        /// 锁定
        /// </summary>
        [Description("锁定")]
        InvState_Lock,
    }

    /// <summary>
    /// 库存状态
    /// </summary>
    public enum SXInvState
    {
        /// <summary>
        /// 已组盘
        /// </summary>
        [Description("已组盘")]
        InvEcecState_BuildUp = 1,
        ///// <summary>
        ///// 入库中
        ///// </summary>
        //[Description("入库中")]
        //InvEcecState_InGoing = 2,
        /// <summary>
        /// 已入库
        /// </summary>
        [Description("已入库")]
        InvEcecState_In = 3,
        /// <summary>
        /// 出库中
        /// </summary>
        [Description("出库中")]
        InvEcecState_OutGoing = 4,
        /// <summary>
        /// 已出库
        /// </summary>
        [Description("已出库")]
        InvEcecState_Out = 5,
    }

    /// <summary>
    /// 任务业务类型
    /// </summary>
    public enum TaskBusType
    {
        /// <summary>
        /// 合金镀铜取满
        /// </summary>
        [Description("合金镀铜取满")]
        TaskBusType_HJ_OneFloorLineStockIn,
        /// <summary>
        /// 一楼出空轮
        /// </summary>
        [Description("一楼出空轮")]
        TaskBusType_HJ_OneFloorEmptySpoolOut,
        /// <summary>
        /// 手动出库
        /// </summary>
        [Description("手动出库")]
        TaskBusType_HJ_ManualOut,
        /// <summary>
        /// 质检回库
        /// </summary>
        [Description("质检回库")]
        TaskBusType_HJ_QualityStockIn,
        /// <summary>
        /// 空轮入库
        /// </summary>
        [Description("空轮入库")]
        TaskBusType_HJ_EmptySpoolStockIn,
        /// <summary>
        /// 其他入库
        /// </summary>
        [Description("其他入库")]
        TaskBusType_HJ_OtherStockIn,
        /// <summary>
        /// 采购550工字轮入库
        /// </summary>
        [Description("采购550工字轮入库")]
        TaskBusType_HJ_PurchaseSpoolStockIn,
    }
    public enum InvInOutType
    {
        /// <summary>
        /// 入库
        /// </summary>
        [Description("入库")]
        In = 1,

        /// <summary>
        /// 出库
        /// </summary>
        [Description("出库")]
        Out = 2,
    }
    public enum ContGrpType
    {
        /// <summary>
        /// 物料盘
        /// </summary>
        [Description("入库")]
        Material = 1,

        /// <summary>
        /// 空盘
        /// </summary>
        [Description("出库")]
        EmptyCon = 2,
    }

  
}
