﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Text;

namespace Wms.Screen.Dto.ZhongTian.Response
{
    /// <summary>
    /// 任务信息
    /// </summary>
    public class TaskInfoDto
    {
        /// <summary>
        /// 任务号
        /// </summary>
        public string TaskCode { get; set; }
        /// <summary>
        /// 任务状态
        /// </summary>
        public string TaskState { get; set; }
        /// <summary>
        /// 任务状态
        /// </summary>
        public TaskStatus TaskStateEnum { get; set; }
        /// <summary>
        /// 任务类型
        /// </summary>
        public string TaskType { get; set; }
        /// <summary>
        /// 单号
        /// </summary>
        public string DocCode { get; set; }
        /// <summary>
        /// 存货编码
        /// </summary>
        public string MaterialCode { get; set; }
        /// <summary>
        /// 存货名称
        /// </summary>
        public string MaterialName { get; set; }
        /// <summary>
        /// 起点
        /// </summary>
        public string BeginPosition { get; set; }
        /// <summary>
        /// 当前地址
        /// </summary>
        public string NowPosition { get; set; }
        /// <summary>
        /// 下个地址
        /// </summary>
        public string NextPosition { get; set; }
        /// <summary>
        /// 终点
        /// </summary>
        public string EndPosition { get; set; }
        /// <summary>
        /// 数量
        /// </summary>
        public decimal Quantity { get; set; }
        /// <summary>
        /// 创建时间
        /// </summary>
        [JsonConverter(typeof(Bozhon.Wms.Entity.Converter.DateTimeConverter))]
        public DateTime CreatedTime { get; set; }

        public string AddTime { get; set; }
        /// <summary>
        /// 工字轮号
        /// </summary>
        public string HWBarCode { get; set; }
        /// <summary>
        /// 规格
        /// </summary>
        public string HWSpec { get; set; }

        public string MatCode { get; set; }

        public string MatName { get; set; }
        /// <summary>
        /// 箱号
        /// </summary>
        public string BoxBarCode { get; set; }
        /// <summary>
        /// 单据类型
        /// </summary>
        public string DocType { get; set; }
        public string Tunnel { get; set; }

    }


    public class SXTaskInfoDto
    {
        /// <summary>
        /// 任务号
        /// </summary>
        public string TaskCode { get; set; }
        /// <summary>
        /// 任务状态
        /// </summary>
        public string TaskState { get; set; }

        public TaskStatus TaskStateEnum { get; set; }

        /// <summary>
        /// 任务类型
        /// </summary>
        public string TaskType { get; set; }
        /// <summary>
        /// 物料号
        /// </summary>
        public string MatCode { get; set; }

        public string BusType { get; set; }
        public int? GoodsType { get; set; }
        public string GoodsTypeName
        {
            get
            {                
                if (GoodsType == 1) return "BS80";
                else if (GoodsType == 2) return "BS60";
                return "0";
            }
        }
        public int Floor { get; set; }
        public string Grade { get; set; }
        /// <summary>
        /// 单号
        /// </summary>
        public string DocCode { get; set; }
        /// <summary>
        /// 存货编码
        /// </summary>
        public string MaterialCode { get; set; }
        /// <summary>
        /// 存货名称
        /// </summary>
        public string MaterialName { get; set; }
        /// <summary>
        /// 起点
        /// </summary>
        public string BeginPosition { get; set; }
        /// <summary>
        /// 当前地址
        /// </summary>
        public string NowPosition { get; set; }
        /// <summary>
        /// 下个地址
        /// </summary>
        public string NextPosition { get; set; }
        /// <summary>
        /// 终点
        /// </summary>
        public string EndPosition { get; set; }
        /// <summary>
        /// 数量
        /// </summary>
        public decimal Quantity { get; set; }
        /// <summary>
        /// 创建时间
        /// </summary>
        [JsonConverter(typeof(Bozhon.Wms.Entity.Converter.DateTimeConverter))]
        public DateTime CreatedTime { get; set; }

        public string AddTime { get; set; }
        /// <summary>
        /// 工字轮号
        /// </summary>
        public string HWBarCode { get; set; }
        /// <summary>
        /// 规格
        /// </summary>
        public string HWSpec { get; set; }
        /// <summary>
        /// 箱号
        /// </summary>
        public string BoxBarCode { get; set; }
        /// <summary>
        /// 单据类型
        /// </summary>
        public string DocType { get; set; }
        public string Tunnel { get; set; }
        public string SKU { get; set; }
        /// <summary>
        /// 第几层
        /// </summary>
        public int Layer { get; set; }
    }
}
