﻿using Bozhon.Wms.Entity.Converter;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Text;

namespace Wms.Screen.Dto.ZhongTian.Response
{
    /// <summary>
    /// 巷道出入设置
    /// </summary>
    public class TunnelConfigDto
    {
        /// <summary>
        /// 主键
        /// </summary>
        [Description("主键")]
        [JsonConverter(typeof(IdConverter))]
        public long Id { get; set; }

        /// <summary>
        /// 仓库名称
        /// </summary>
        [Description("仓库代码")]
        public string WarehouseCode { get; set; }
        /// <summary>
        /// 仓库名称
        /// </summary>
        [Description("仓库名称")]
        public string WarehouseName { get; set; }

        /// <summary>
        /// 巷道
        /// </summary>
        [Description("巷道")]
        public string Tunnel { get; set; }

        /// <summary>
        /// 入库状态  启用  禁用
        /// </summary>
        [Description("入库状态")]
        public string InStates { get; set; }

        /// <summary>
        /// 入库状态  1-启用  0-禁用
        /// </summary>
        [Description("入库状态")]
        public int InState { get; set; }

        /// <summary>
        /// 出库状态 1-启用  0-禁用
        /// </summary>
        [Description("出库状态")]
        public int OutState { get; set; }
        /// <summary>
        /// 出库状态 启用  禁用
        /// </summary>
        [Description("出库状态")]
        public string OutStates { get; set; }
    }

    /// <summary>
    /// 巷道配置信息
    /// </summary>
    public class TunnelConfigEntity
    {
        /// <summary>
        /// 主键
        /// </summary>
        [Description("主键")]
        [JsonConverter(typeof(IdConverter))]
        public long Id { get; set; }


        /// <summary>
        /// 仓库代码
        /// </summary> 
        public string WarehouseCode { get; set; }
        /// <summary>
        /// 仓库名称
        /// </summary> 
        public string WarehouseName { get; set; }

        /// <summary>
        /// 巷道
        /// </summary> 
        public string Tunnels { get; set; }

        /// <summary>
        /// 关联的配置代码
        /// </summary> 
        public string ConfigCode { get; set; }
        /// <summary>
        /// 关联的配置名称
        /// </summary> 
        public string ConfigName { get; set; }
        /// <summary>
        /// 关联的配置类型
        /// </summary>
        public string ConfigType { get; set; }
        /// <summary>
        /// 禁用列表
        /// </summary>
        public string ConfigContents { get; set; }
    }
    public class TunnelCountTemp
    {
        public string Tunnel { get; set; }
        public int Count { get; set; }
    }
}
