﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Wms.Screen.Dto.ZhongTian.Response
{
    public class ZTBillDto : BillDto
    {
        /// <summary>
        /// 库存数量
        /// </summary>
        public decimal StockQuantity { get; set; }
    }
    public class BillDto
    {
        /// <summary>
        /// 外部单据号
        /// </summary>
        public string OutDocumentCode { get; set; }

        /// <summary>
        /// 物料名称
        /// </summary>
        public string MaterialName { get; set; }
        /// <summary>
        /// 物料编码
        /// </summary>
        public string MaterialCode { get; set; }
        /// <summary>
        /// 差异数量
        /// </summary>
        public decimal ActualQuantity { get; set; }
        /// <summary>
        /// 完成数量
        /// </summary>
        public decimal ExecutedQuantity { get; set; }
        /// <summary>
        /// 派工数量
        /// </summary>
        public decimal OutDocumentQuantity { get; set; }
        /// <summary>
        /// 目标产线
        /// </summary>
        public string ProductionLine { get; set; }
        /// <summary>
        /// 供应商
        /// </summary>
        public string ContainerCode { get; set; }
        /// <summary>
        /// 单据类型
        /// </summary>
        public string TypeCode { get; set; }
        /// <summary>
        /// 单据状态
        /// </summary>
        public string StateCode { get; set; }

    }
    /// <summary>
    /// 码垛信息
    /// </summary>
    public class StackDto
    {
        /// <summary>
        /// 托盘号
        /// </summary>
        public string ContainerCode { get; set; }
        /// <summary>
        /// 托盘类型
        /// </summary>
        public string ContainerType { get; set; }
        /// <summary>
        /// 状态
        /// </summary>
        public string Statue { get; set; }
        /// <summary>
        /// 等级
        /// </summary>
        public string Grade { get; set; }
        /// <summary>
        /// 垛型编码
        /// </summary>
        public string Code { get; set; }
        /// <summary>
        /// 是否异常
        /// </summary>
        public bool IsFail { get; set; }
        /// <summary>
        /// 异常原因
        /// </summary>
        public string FailReason { get; set; }
    }

    public class TunelCount
    {
        public int ContGrpType { get; set; }
        public int? Tunnel { get; set; }
        public int Qty { get; set; }
    }

    public class WarningQtyModel
    {
        public string Name { get; set; }

        public int Qty { get; set; }
        public int WarnQty { get; set; }

        public int DiffQty
        {
            get
            {
                return Qty - WarnQty;
            }
        }
    }
    /// <summary>
    /// 
    /// </summary>
    public class BoilerNoMatCodeModel
    {
        public string MatCode { get; set; } 
        public string BoilerNo { get; set; }

        public int Qty { get; set; }
    }

    public class DeliveryDetails
    {
        /// <summary>
        ///  待发货单数
        /// </summary>
        public int ShippingOrderQuantity { get; set; }

        /// <summary>
        ///  待发货箱数
        /// </summary>
        public int ShippingBoxQuantity { get; set; }

        /// <summary>
        ///   产品信息
        /// </summary>
        public List<ProductInfo> LProductInfos { get; set; } = new List<ProductInfo>();

        /// <summary>
        ///   产品信息
        /// </summary>
        public List<ProductInfo> RProductInfos { get; set; } = new List<ProductInfo>();

        public string Value { get; set; }
    }

    public class ProductInfo
    {
        /// <summary>
        /// 设备号
        /// </summary>
        public string DeviceId { get; set; }

        /// <summary>
        /// 任务号
        /// </summary>
        public string TaskId { get; set; }

        /// <summary>
        ///  序号
        /// </summary>
        public int Index { get; set; }

        /// <summary>
        ///  箱号  
        /// </summary>
        public string BoxBarCode { get; set; }

        /// <summary>
        /// 绕向
        /// </summary>
        public string Winding { get; set; }

        /// <summary>
        /// 单号
        /// </summary>
        public string SalesDoc { get; set; }

        /// <summary>
        /// 规格
        /// </summary>
        public string MatName { get; set; }
    }
}
