﻿using SqlSugar;
using System;
using System.Collections.Generic;
using System.Data;
using System.Dynamic;
using System.Linq.Expressions;
using System.Threading.Tasks;

namespace Wms.Screen.SqlSugar.Repository
{
    public interface IRepository<T> where T : class
    {
        

        

        DbResult<bool> UseTran(Action action);

        DbResult<bool> UseTran(SqlSugarClient client, Action action);

        bool UseTran2(Action action);

        

        #region query

        bool IsAny(Expression<Func<T, bool>> expression);

        ISugarQueryable<T> Queryable();
        ISugarQueryable<T> QueryableIncludeDelete();
        ISugarQueryable<T> Queryable(Expression<Func<T, bool>> expression);
        ISugarQueryable<ExpandoObject> Queryable(string tableName, string shortName);

        //ISugarQueryable<T, T1, T2> Queryable<T1, T2>() where T1 : class where T2 : new();

        List<T> QueryableToList(Expression<Func<T, bool>> expression);

        Task<List<T>> QueryableToListAsync(Expression<Func<T, bool>> expression);

        //string QueryableToJson(string select, Expression<Func<T, bool>> expressionWhere);

        List<T> QueryableToList(string tableName);

        T QueryableToEntity(Expression<Func<T, bool>> expression);

        List<T> QueryableToList(string tableName, Expression<Func<T, bool>> expression);

        (List<T>, int) QueryableToPage(Expression<Func<T, bool>> expression, int pageIndex = 0, int pageSize = 10);

        (List<T>, int) QueryableToPage(Expression<Func<T, bool>> expression, string order, int pageIndex = 0, int pageSize = 10);

        (List<T>, int) QueryableToPage(Expression<Func<T, bool>> expression, Expression<Func<T, object>> orderFiled, string orderBy, int pageIndex = 0, int pageSize = 10);

        List<T> SqlQueryToList(string sql, object obj = null);

        #endregion query

        #region Procedure

        DataTable UseStoredProcedureToDataTable(string procedureName, List<SugarParameter> parameters);

        (DataTable, List<SugarParameter>) UseStoredProcedureToTuple(string procedureName, List<SugarParameter> parameters);

        #endregion Procedure
    }
}
