﻿using SqlSugar;
using System;
using System.Collections.Generic;
using System.Text;

namespace Wms.Screen.SqlSugar.ZhongTian
{
    [SugarTable("Bill_BomSetInfo")]
    public class BillBomsetinfo
    {

        /// <summary> 
        /// 主表id(垛型id)
        /// </summary> 
        [SugarColumn(ColumnDataType = "bigint", IsNullable = false, ColumnDescription = "主表id")]
        public long BomSetHdrId { get; set; }

        /// <summary> 
        /// 是否停用
        /// </summary> 
        [SugarColumn(ColumnDataType = "int", IsNullable = false)]
        public int IsStop { get; set; }

        /// <summary> 
        /// 有/无
        /// </summary> 
        [SugarColumn(ColumnDataType = "int", IsNullable = false, ColumnDescription = "有/无")]
        public int IsEmpty { get; set; }

        /// <summary> 
        /// 坐标号(1-60的编号)
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = false, ColumnDescription = "1-60的编号")]
        public string XYNo { get; set; }

        /// <summary> 
        /// 09垛型里面的行（1-12）
        /// </summary> 
        [SugarColumn(ColumnDataType = "int", IsNullable = true, ColumnDescription = "行")]
        public int? Row { get; set; }

        /// <summary> 
        /// 物料编码
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "物料编码")]
        public string MatCode { get; set; }

        /// <summary> 
        /// 物料Id
        /// </summary> 
        [SugarColumn(ColumnDataType = "bigint", IsNullable = false, ColumnDescription = "物料Id")]
        public long MatId { get; set; }

        /// <summary> 
        /// 正/反面
        /// </summary> 
        [SugarColumn(ColumnDataType = "int", IsNullable = false, ColumnDescription = "正/反面")]
        public int SideNum { get; set; }

        /// <summary> 
        /// 工字轮型号
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "工字轮型号")]
        public string SpoolType { get; set; }

        /// <summary> 
        /// 钢丝类型(单/双丝)
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = false, ColumnDescription = "单/双丝")]
        public string SilkType { get; set; }

        /// <summary> 
        /// 钢丝直径
        /// </summary> 
        [SugarColumn(ColumnDataType = "decimal", Length = 18, IsNullable = false, ColumnDescription = "钢丝直径")]
        public decimal SilkDiam { get; set; }

        /// <summary> 
        /// 钢丝直径上限
        /// </summary> 
        [SugarColumn(ColumnDataType = "int", IsNullable = true, ColumnDescription = "钢丝直径上限")]
        public int SilkDiamMaxCount { get; set; }

        /// <summary> 
        /// 数量上限
        /// </summary> 
        [SugarColumn(ColumnDataType = "int", IsNullable = true, ColumnDescription = "数量上限")]
        public int QtyMaxCount { get; set; }

        /// <summary> 
        /// 是否芯股
        /// </summary> 
        [SugarColumn(ColumnDataType = "int", IsNullable = false, ColumnDescription = "是否芯股")]
        public int IsCore { get; set; }

        /// <summary> 
        /// 是否混合料行（09垛型使用，1是0否）
        /// </summary> 
        [SugarColumn(ColumnDataType = "int", IsNullable = false)]
        public int IsMixRow { get; set; }

        /// <summary> 
        /// 混合料行编码
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "混合料行编码")]
        public string MixRowCode { get; set; }
        /// <summary> 
        /// 第一种第二种第三种
        /// </summary> 
        [SugarColumn(ColumnDataType = "int", IsNullable = true, ColumnDescription = "第一种第二种第三种")]
        public int? CategoryId { get; set; }
    }
}
