﻿using System; 
using System.Collections.Generic;
using SqlSugar;
using Wms.Screen.SqlSugar;

namespace wms.sqlsugar.model.fj
{
    [Tenant("fj")]
    [SugarTable("Bill_BomSetGrp")]
    public partial class BillBomsetgrp : BaseModel
    {
        /// <summary> 
        /// 是否停用
        /// </summary> 
        [SugarColumn(ColumnDataType = "int", IsNullable = false)]
        public int IsStop { get; set; }

        /// <summary> 
        /// IsDelete
        /// </summary> 
        [SugarColumn(ColumnDataType = "int", IsNullable = false)]
        public int IsDelete { get; set; }

        /// <summary> 
        /// 垛型编码
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = false)]
        public string Code { get; set; }

        /// <summary> 
        /// 垛型名称
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 100, IsNullable = false)]
        public string Name { get; set; }

       
        /// <summary> 
        /// 短垛型编码
        /// </summary> 
        [SugarColumn(ColumnDataType = "smallint", IsNullable = false)]
        public int ShortCode { get; set; }
        /// <summary> 
        /// 帘线物料编码
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "帘线物料编码")]
        public string ProMaterCode { get; set; }

        /// <summary> 
        /// BomCode（投料信息）
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "投料物流编码")]
        public string BomCode { get; set; }

        /// <summary>
        /// 
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 500, IsNullable = false)]
        public string BomName { get; set; }
        /// <summary> 
        /// 工字轮个数
        /// </summary> 
        [SugarColumn(ColumnDataType = "int", IsNullable = false, ColumnDescription = "工字轮个数")]
        public int HWCountQty { get; set; }

        /// <summary>
        /// 总工字轮个数
        /// </summary>
        public int TotalQty { get; set; }
        /// <summary> 
        /// 托盘类型 1：09型托盘，2：非09托盘
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = false, ColumnDescription = "托盘类型")]
        public string TpTypeCode { get; set; }

        /// <summary> 
        /// 类型 1A级品正常 2B级品 3异常
        /// </summary> 
        [SugarColumn(ColumnDataType = "int", IsNullable = false, ColumnDescription = "类型 1A级品正常 2B级品 3异常")]
        public int Category { get; set; }
        /// <summary> 
        /// 层数
        /// </summary> 
        [SugarColumn(ColumnDataType = "int", IsNullable = false, ColumnDescription = "层数")]
        public int LayerCountQty { get; set; }

        /// <summary> 
        /// 非业务相关（区分表单），记录类型DFM15 DFM9 DFM6 DOF2等类型的跺型
        /// </summary> 
        [SugarColumn(ColumnDataType = "int", IsNullable = false, ColumnDescription = "非业务相关，记录类型DFM15 DFM9 DFM6 DOF2等类型的跺型")]
        public int StampType { get; set; }

        /// <summary> 
        /// 非业务相关（区分表单），记录类型 DFM6 DOF4等类型的子跺型
        /// </summary> 
        [SugarColumn(ColumnDataType = "int", IsNullable = false, ColumnDescription = "非业务相关，记录类型DFM15 DFM9 DFM6 DOF2等类型的跺型")]
        public int StampChildType { get; set; } 
    }
}

