﻿using System; 
using System.Collections.Generic;
using SqlSugar;
using Wms.Screen.SqlSugar;

namespace wms.sqlsugar.model.hj
{
    [Tenant("hj")]
    [SugarTable("Bill_InvNow")]
    public   class BillInvnow : BaseModel
    {

        /// <summary> 
        /// 仓库id
        /// </summary> 
        [SugarColumn(ColumnDataType = "bigint", IsNullable = false, ColumnDescription = "仓库id")]
        public long WarehouseId { get; set; }

        /// <summary> 
        /// 组盘组id
        /// </summary> 
        [SugarColumn(ColumnDataType = "bigint", IsNullable = false, ColumnDescription = "组盘组id")]
        public long ContGrpId { get; set; }

        /// <summary> 
        /// 载具编号
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "载具编号")]
        public string ContGrpBarCode { get; set; }

        /// <summary> 
        /// 库存类型(1物料盘2空盘)
        /// </summary> 
        [SugarColumn(ColumnDataType = "int", IsNullable = false, ColumnDescription = "库存类型(1物料盘2空盘)")]
        public int ContGrpType { get; set; }

        /// <summary> 
        /// 箱条码
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "箱条码")]
        public string BoxBarCode { get; set; }

        /// <summary> 
        /// bom单号
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "bom单号")]
        public string BomDocsNo { get; set; }

        /// <summary> 
        /// bom物料id
        /// </summary> 
        [SugarColumn(ColumnDataType = "bigint", IsNullable = false, ColumnDescription = "bom物料id")]
        public long BomMatId { get; set; }

        /// <summary> 
        /// bom物料编码
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "bom物料编码")]
        public string BomMatCode { get; set; }

        /// <summary> 
        /// bom物料名称
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 100, IsNullable = true, ColumnDescription = "bom物料名称")]
        public string BomMatName { get; set; }

        /// <summary> 
        /// 垛型id
        /// </summary> 
        [SugarColumn(ColumnDataType = "bigint", IsNullable = false, ColumnDescription = "垛型id")]
        public long BomSetId { get; set; }

        /// <summary> 
        /// 库存执行状态
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "库存执行状态")]
        public string ExecStateCode { get; set; }

        /// <summary> 
        /// 库存状态
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "库存状态")]
        public string InvStateCode { get; set; }

        /// <summary> 
        /// 执行单号
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "执行单号")]
        public string ExecDocsNo { get; set; }

        /// <summary> 
        /// 执行单行号
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "执行单行号")]
        public string ExecDocsRowNo { get; set; }

        /// <summary> 
        /// 执行单类型
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "执行单类型")]
        public string ExecDocsTypeCode { get; set; }

        /// <summary> 
        /// 出入类型
        /// </summary> 
        [SugarColumn(ColumnDataType = "int", IsNullable = false, ColumnDescription = "出入类型")]
        public int InvInOut { get; set; }

        /// <summary> 
        /// 执行人
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "执行人")]
        public string ExecWho { get; set; }

        /// <summary> 
        /// 执行时间
        /// </summary> 
        [SugarColumn(ColumnDataType = "datetime", IsNullable = false, ColumnDescription = "执行时间")]
        public DateTime ExecTime { get; set; }

        /// <summary> 
        /// 行
        /// </summary> 
        [SugarColumn(ColumnDataType = "int", IsNullable = false, ColumnDescription = "行")]
        public int PutRow { get; set; }

        /// <summary> 
        /// 列
        /// </summary> 
        [SugarColumn(ColumnDataType = "int", IsNullable = false, ColumnDescription = "列")]
        public int PutCol { get; set; }

        /// <summary> 
        /// 层
        /// </summary> 
        [SugarColumn(ColumnDataType = "int", IsNullable = false, ColumnDescription = "层")]
        public int PutLayer { get; set; }

        /// <summary> 
        /// 库存编码
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "库存编码")]
        public string InvBarCode { get; set; }

        /// <summary> 
        /// 入库单号
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "入库单号")]
        public string InDocsNo { get; set; }

        /// <summary> 
        /// 入库单行号
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "入库单行号")]
        public string InDocsRowNo { get; set; }

        /// <summary> 
        /// 供应商编码
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "供应商编码")]
        public string SuppCode { get; set; }

        /// <summary> 
        /// 供应商名称
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "供应商名称")]
        public string SuppName { get; set; }

        /// <summary> 
        /// 客户
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "客户")]
        public string CustCode { get; set; }

        /// <summary> 
        /// 客户名称
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "客户名称")]
        public string CustName { get; set; }

        /// <summary> 
        /// 物料id
        /// </summary> 
        [SugarColumn(ColumnDataType = "bigint", IsNullable = false, ColumnDescription = "物料id")]
        public long MatId { get; set; }

        /// <summary> 
        /// 物料编码
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "物料编码")]
        public string MatCode { get; set; }

        /// <summary> 
        /// 物料名称
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 100, IsNullable = true, ColumnDescription = "物料名称")]
        public string MatName { get; set; }

        /// <summary> 
        /// 总重量
        /// </summary> 
        [SugarColumn(ColumnDataType = "decimal", Length = 18, IsNullable = false, ColumnDescription = "总重量")]
        public decimal TolWQty { get; set; }

        /// <summary> 
        /// 净重
        /// </summary> 
        [SugarColumn(ColumnDataType = "decimal", Length = 18, IsNullable = false, ColumnDescription = "净重")]
        public decimal NetWQty { get; set; }


        /// <summary> 
        /// 皮重
        /// </summary> 
        [SugarColumn(ColumnDataType = "decimal", Length = 18, IsNullable = false, ColumnDescription = "皮重")]
        public decimal TareWQty { get; set; }

        /// <summary> 
        /// 长度
        /// </summary> 
        [SugarColumn(ColumnDataType = "decimal", Length = 18, IsNullable = false, ColumnDescription = "长度")]
        public decimal LengthQty { get; set; }

        /// <summary> 
        /// 碳当量
        /// </summary> 
        [SugarColumn(ColumnDataType = "decimal", Length = 18, IsNullable = false, ColumnDescription = "碳当量")]
        public decimal CaQty { get; set; }

        /// <summary> 
        /// 焊点数量
        /// </summary> 
        [SugarColumn(ColumnDataType = "decimal", Length = 18, IsNullable = false, ColumnDescription = "焊点数量")]
        public decimal SolderQty { get; set; }

        /// <summary> 
        /// ContUsageQty
        /// </summary> 
        [SugarColumn(ColumnDataType = "int", IsNullable = false)]
        public int ContUsageQty { get; set; }

        /// <summary> 
        /// 批号
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "批号")]
        public string BatchNo { get; set; }

        /// <summary> 
        /// 生产时间
        /// </summary> 
        [SugarColumn(ColumnDataType = "datetime", IsNullable = false, ColumnDescription = "生产时间")]
        public DateTime ProductTime { get; set; }

        /// <summary> 
        /// 首次入库时间
        /// </summary> 
        [SugarColumn(ColumnDataType = "datetime", IsNullable = false, ColumnDescription = "首次入库时间")]
        public DateTime OneInTime { get; set; }

        /// <summary> 
        /// 盘条条码
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "盘条条码")]
        public string RodBarCode { get; set; }

        /// <summary> 
        /// 工字轮条码
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "工字轮条码")]
        public string HWBarCode { get; set; }

        /// <summary> 
        /// RFID编号
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "RFID编号")]
        public string RFIDBarCode { get; set; }

        /// <summary> 
        /// CLBarCode
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string CLBarCode { get; set; }

        /// <summary> 
        /// 工字轮类型
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "工字轮类型")]
        public string HWTypeCode { get; set; }

        /// <summary> 
        /// 炉号
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "炉号")]
        public string BoilerNo { get; set; }

        /// <summary> 
        /// 包号
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "包号")]
        public string PackNo { get; set; }

        /// <summary> 
        /// 牌号
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "牌号")]
        public string BrandNo { get; set; }

        /// <summary> 
        /// 执行标准
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "执行标准")]
        public string ExecStd { get; set; }

        /// <summary> 
        /// 许可证号
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "许可证号")]
        public string LicenceCode { get; set; }

        /// <summary> 
        /// 改手盘标记
        /// </summary> 
        [SugarColumn(ColumnDataType = "bit", IsNullable = false, ColumnDescription = "改手盘标记")]
        public bool IsSurplus { get; set; }

        /// <summary> 
        /// 返工标记
        /// </summary> 
        [SugarColumn(ColumnDataType = "bit", IsNullable = false, ColumnDescription = "返工标记")]
        public bool IsRework { get; set; }

        /// <summary> 
        /// 是否黑盘
        /// </summary> 
        [SugarColumn(ColumnDataType = "bit", IsNullable = false, ColumnDescription = "是否黑盘")]
        public bool IsBlack { get; set; }

        /// <summary> 
        /// 是否芯股
        /// </summary> 
        [SugarColumn(ColumnDataType = "bit", IsNullable = false, ColumnDescription = "是否芯股")]
        public bool IsCore { get; set; }

        /// <summary> 
        /// 快投标记
        /// </summary> 
        [SugarColumn(ColumnDataType = "bit", IsNullable = false, ColumnDescription = "快投标记")]
        public bool IsFast { get; set; }

        /// <summary> 
        /// 是否异常
        /// </summary> 
        [SugarColumn(ColumnDataType = "bit", IsNullable = false, ColumnDescription = "是否异常")]
        public bool IsFail { get; set; }

        /// <summary> 
        /// 异常原因
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 200, IsNullable = true, ColumnDescription = "异常原因")]
        public string FailReason { get; set; }

        /// <summary> 
        /// 钢丝类型编码
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "钢丝类型编码")]
        public string SilkTypeCode { get; set; }

        /// <summary> 
        /// 等级
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "等级")]
        public string Grade { get; set; }

        /// <summary> 
        /// 是否退料
        /// </summary> 
        [SugarColumn(ColumnDataType = "bit", IsNullable = false, ColumnDescription = "是否退料")]
        public bool IsBack { get; set; }

        /// <summary> 
        /// 退料原因
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 200, IsNullable = true, ColumnDescription = "退料原因")]
        public string BackReason { get; set; }

        /// <summary> 
        /// 是否扭转检测
        /// </summary> 
        [SugarColumn(ColumnDataType = "bit", IsNullable = false, ColumnDescription = "是否扭转检测")]
        public bool IsTorsChk { get; set; }

        /// <summary> 
        /// 扭转次数
        /// </summary> 
        [SugarColumn(ColumnDataType = "int", IsNullable = false, ColumnDescription = "扭转次数")]
        public int TorsChkQty { get; set; }

        /// <summary> 
        /// 扭转检测时间
        /// </summary> 
        [SugarColumn(ColumnDataType = "datetime", IsNullable = false, ColumnDescription = "扭转检测时间")]
        public DateTime TorsChkTime { get; set; }

        /// <summary> 
        /// 扭转检测结果值
        /// </summary> 
        [SugarColumn(ColumnDataType = "decimal", Length = 18, IsNullable = true, ColumnDescription = "扭转检测结果值")]
        public decimal? TorsChkValue { get; set; }

        /// <summary> 
        /// 扭转检测设备号
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "扭转检测设备号")]
        public string TorsChkMachCode { get; set; }

        /// <summary> 
        /// 工序订单号
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "工序订单号")]
        public string ProcessDocsCode { get; set; }

        /// <summary> 
        /// 生产机台号
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "生产机台号")]
        public string ProductMachCode { get; set; }

        /// <summary> 
        /// ProductLineNo
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "ProductLineNo")]
        public string ProductLineNo { get; set; }

        /// <summary> 
        /// 时效时长
        /// </summary> 
        [SugarColumn(ColumnDataType = "decimal", Length = 18, IsNullable = false, ColumnDescription = "净重")]
        public decimal HoldDuration { get; set; }
        /// <summary> 
        /// Remark
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 500, IsNullable = true)]
        public string Remark { get; set; }

        /// <summary> 
        /// Default1
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 100, IsNullable = true)]
        public string Default1 { get; set; }

        /// <summary> 
        /// Default2
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 100, IsNullable = true)]
        public string Default2 { get; set; }

        /// <summary> 
        /// Default3
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 100, IsNullable = true)]
        public string Default3 { get; set; }

        /// <summary> 
        /// AddWho
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = false)]
        public string AddWho { get; set; }

        /// <summary> 
        /// AddTime
        /// </summary> 
        [SugarColumn(ColumnDataType = "datetime", IsNullable = false)]
        public DateTime AddTime { get; set; }

        /// <summary> 
        /// EditWho
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = false)]
        public string EditWho { get; set; }

        /// <summary> 
        /// EditTime
        /// </summary> 
        [SugarColumn(ColumnDataType = "datetime", IsNullable = false)]
        public DateTime EditTime { get; set; }

        /// <summary> 
        /// 尺寸
        /// </summary> 
        [SugarColumn(ColumnDataType = "int", IsNullable = false, ColumnDescription = "尺寸")]
        public int Size { get; set; }

        /// <summary> 
        /// Memo
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 500, IsNullable = true)]
        public string Memo { get; set; }

    }
}

