﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Threading.Tasks;

namespace zt.screen.api.Extensions
{
    public class CommonlyFuntion
    { /// <summary>
      /// 
      /// </summary>
      /// <typeparam name="T">目标对象</typeparam>
      /// <typeparam name="S">源对象</typeparam>
      /// <param name="t">目标对象</param>
      /// <param name="s">源对象</param>
        public static void ConvertToEntity<T, S>(T t, S s)
        {
            PropertyInfo[] ps = s.GetType().GetProperties(BindingFlags.Public | BindingFlags.Instance);
            Type tar = t.GetType();
            foreach (var item in ps)
            {
                if (item.PropertyType.BaseType.Name == "Enum")
                    continue;
                PropertyInfo tarPro = tar.GetProperty(item.Name);
                if (tarPro == null)
                    continue;
                object value = item.GetValue(s, null);
                if (value == null)
                {
                    switch (item.PropertyType.Name)
                    {
                        case "Int32":
                        case "Double":
                            value = 0;
                            break;
                        case "String":
                            value = string.Empty;
                            break;
                        case "DateTime":
                            value = DateTime.Now;
                            break;
                    }
                }
                if (value != null)
                    tarPro.SetValue(t, value, null);

            }
        }


        /// <summary>
        /// 
        /// </summary>
        /// <typeparam name="T">目标对象</typeparam>
        /// <typeparam name="S">源对象</typeparam>
        /// <param name="t">目标对象</param>
        /// <param name="lsts">源对象集合</param>
        /// <returns>目标集合对象</returns>
        public static List<T> ConvertToListEntity<T, S>(List<S> lsts)
        {
            List<T> lst = new List<T>();
            foreach (var s in lsts)
            {
                T t1 = ConvertByObject<T>(s);
                lst.Add(t1);
            }
            return lst;
        }


        public static T ConvertByObject<T>(object soure)
        {
            var t = Activator.CreateInstance<T>();
            if (soure != null)
            {
                PropertyInfo[] ps = soure.GetType().GetProperties(BindingFlags.Public | BindingFlags.Instance);
                Type tar = t.GetType();
                foreach (var item in ps)
                {
                    if (item.PropertyType.BaseType.Name == "Enum")
                        continue;
                    PropertyInfo tarPro = tar.GetProperty(item.Name);
                    if (tarPro == null)
                        continue;
                    object value = item.GetValue(soure, null);
                    if (value == null)
                    {
                        switch (item.PropertyType.Name)
                        {
                            case "Int32":
                            case "Double":
                                value = 0;
                                break;
                            case "String":
                                value = string.Empty;
                                break;
                            case "DateTime":
                                value = DateTime.Now;
                                break;
                        }
                    }
                    if (value != null)
                    {
                        if (item.PropertyType.Name == "DateTime")
                        {
                            if (value.ToString() == "0001/1/1 0:00:00")
                            {

                                value = DateTime.Now;
                            }
                        }
                        tarPro.SetValue(t, value, null);
                    }

                }
            }

            return t;
        }
    }
}

