﻿using Microsoft.Extensions.Hosting;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Wms.Screen.Dto.ZhongTian;
using Wms.Screen.Service.IService;
using Wms.Screen.Service.Service;

namespace zt.screen.api.Extensions
{
    /// <summary>
    /// netcore主机服务
    /// </summary>
    public class HostedServiceExtension : IHostedService
    {
        private Task _executingTask;
        private CancellationTokenSource _cts;
        private IFileService _service;
        /// <summary>
        /// 读取配置文件信息
        /// </summary>
        /// <param name="service"></param>
        public HostedServiceExtension(IFileService service)
        {
            _service = service;
        }
        /// <summary>
        /// Start service
        /// </summary>
        /// <param name="cancellationToken"></param>
        /// <returns></returns>
        public Task StartAsync(CancellationToken cancellationToken)
        {
            // Create a linked token so we can trigger cancellation outside of this token's cancellation
            _cts = CancellationTokenSource.CreateLinkedTokenSource(cancellationToken);

            //读取文件
            //入库，设备号
            //var YMInList = _service.ReadKeyList("InWareHouse");
            //foreach (var inHouse in YMInList)
            //{
            //    string _iniReadValue = _service.IniReadValue("InWareHouse", inHouse);
            //    if (!string.IsNullOrEmpty(_iniReadValue))
            //    {
            //        InOutEquipment.WorkShopWithEquipment.Add(new WorkShopWithEquipment()
            //        {
            //            InOrOut = "In",
            //            WorkShop = inHouse,
            //            Equipments = _iniReadValue.Split(",").Distinct().ToList()//_service.IniReadValue("InWareHouse", inHouse).Split(",").ToList()
            //        });
            //    }
            //}
            //出库，设备号
            var YMOutList = _service.ReadKeyList("OutWareHouse");
            foreach (var outHouse in YMOutList)
            {
                InOutEquipment.WorkShopWithEquipment.Add(new WorkShopWithEquipment()
                {
                    InOrOut = "Out",
                    WorkShop = outHouse,
                    Equipments = _service.IniReadValue("OutWareHouse", outHouse).Split(",").ToList()
                });

            }
            //月台入库口
            //var YTInList = _service.ReadKeyList("YTInWareHouse");
            //foreach (var outHouse in YTInList)
            //{
            //    InOutEquipment.YTWorkShopWithEquipment.Add(new WorkShopWithEquipment()
            //    {
            //        InOrOut = "In",
            //        WorkShop = outHouse,
            //        Equipments = _service.IniReadValue("YTInWareHouse", outHouse).Split(",").ToList()
            //    });

            //}
            //月台出库口
            //var YTOutList = _service.ReadKeyList("YTOutWareHouse");
            //foreach (var outHouse in YTOutList)
            //{
            //    InOutEquipment.YTWorkShopWithEquipment.Add(new WorkShopWithEquipment()
            //    {
            //        InOrOut = "Out",
            //        WorkShop = outHouse,
            //        Equipments = _service.IniReadValue("YTOutWareHouse", outHouse).Split(",").ToList()
            //    });

            //}

            //车间汇总  原膜1车间,原膜2车间...
            //也可用于虚拟车间：
            var WorkShopList = _service.ReadKeyList("WorkShopWithLine");
            foreach (var workShop in WorkShopList)
            {
                InOutEquipment.DeopWithWOrkShops.Add(new DeptWithWorkShop()
                {
                    Dept = workShop,
                    WorkShopList = _service.IniReadValue("WorkShopWithLine", workShop).Split(",").ToList()
                });
            }



            return Task.CompletedTask;// _executingTask.IsCompleted ? _executingTask : Task.CompletedTask;
            // If the task is completed then return it, otherwise it's running
        }

        /// <summary>
        /// Stop service
        /// </summary>
        /// <param name="cancellationToken"></param>
        /// <returns></returns>
        public async Task StopAsync(CancellationToken cancellationToken)
        {
            // Stop called without start
            if (_executingTask == null)
            {
                return;
            }

            _cts.Cancel();

            // Wait until the task completes or the stop token triggers
            await Task.WhenAny(_executingTask, Task.Delay(-1, cancellationToken));

            // Throw if cancellation triggered
            cancellationToken.ThrowIfCancellationRequested();
        }
    }
}
